#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Functions for transforming data.


It considers the following tensor format:

    (N, C, D, H, W)

where N is the number in the bach, C is the channel (physical
quantity), D is the time frame (time dimension), H and W are
the 2D solution grid indexes.


All manipulations consider a 2D field, modifications are
necessary to account for a 3D field. Some functions are inspired
on the torchvision source code:

https://github.com/pytorch/vision/blob/master/torchvision/transforms/

"""


# native modules
##none##

# third-party modules
import torch

# local modules
##none##


def mean(tensor, mask=None):
    """ Calculate mean of arrays defined by the last
    2 or 3 dimensions of tensor.
    """
    tensor = tensor.contiguous()
    op_shape = (tensor.shape[:3].numel(), -1) 
    if mask is not None:
        mask_ = mask.to(tensor.dtype).contiguous()
        ret = (tensor*mask_).view(op_shape).sum(-1)
        ret.div_(mask_.view(op_shape).sum(-1))
    else:
        ret = tensor.view(op_shape).mean(-1)
    return ret.view(tensor.shape[:3])



def std(tensor, mask=None):
    """ Calculate standard deviation of arrays defined by the last
    2 dimensions of tensor.
    """
    tensor = tensor.contiguous()
    op_shape = (tensor.shape[:3].numel(), -1) 

    if mask is not None:
        mask_ = mask.to(tensor.dtype).contiguous()
        mean_ = mean(tensor, mask=mask)
        mean_ = mean_.view(mean_.shape  + (1,)*(tensor.dim()-3)) 
        ret = ((tensor*mask_ - mean_)**2).view(op_shape).sum(-1)
        # unbiased std
        ret.div_(mask_.view(op_shape).sum(-1) - 1)
        ret.sqrt_()
    else:
        ret = tensor.view(op_shape).std(-1)
    return ret.view(tensor.shape[:3])



def std_first_frame(tensor, mask=None):
    """ Calculate std of the first frame (third dimension).

    ----------    
    ARGUMENTS

        tensor: tensor image of size (N, C, 1, ... , H, W).

    ----------                 
    RETURNS

        tensor: tensor image of the std of the first frame in
                the format (N, C, 1, ..., 1, 1)

    """
    
    # calculate the std of the first frame (dimension 2), all channels
    std_frame = std(tensor, mask)
    
    # adds the frame dimension back and 2 dimensions at the end to allow 
    # broadcasting
    return std_frame[(...,) + (None,)*(tensor.dim()-3)]



def mean_first_frame(tensor, mask=None):
    """ Calculate mean of the first frame (third dimension).

    ----------    
    ARGUMENTS

        tensor: tensor image of size (N, C, 1, ... , H, W).

    ----------                 
    RETURNS

        tensor: tensor image of the std of the first frame in
                the format (N, C, 1, ..., 1, 1)

    """
    
    # calculate the std of the first frame (dimension 1), all channels
    mean_frame = mean(tensor, mask)
    
    # adds the frame dimension back and 2 or 3 dimensions at the end to allow 
    # broadcasting
    return mean_frame[(...,) + (None,)*(tensor.dim()-3)]



def multiply_frame_(tensor, frame, factors, mask=None):
    """ Multiple every frame (third dimension) by individual values 
    considering a channel (second dimension) independent factor.

    
    In-place operation (mutates input tensor!).
    
    ----------    
    ARGUMENTS
    
        tensor: tensor image of size (N, C, D, ..., H, W) to be modified.
        frame: tensor with the multiplying scalars for every frame
               (third dimension), all other dimensions (except the
               2D array) must be the same. The format generated by
               mean_first_frame or std_first_frame.
        factors: tensor with the value for scaling the multiplication
                 for each channel (must have as much values as channels -
                 second dimension). Ex: if [3, 1, 2], the first
                 channel is multiplied by 3*frame[:,:,0], the second by 
                 1*frame[:,:,1] and the third by 2*frame[:,:,2].
    
    ----------                 
    RETURNS

        tensor: tensor image of multiplied tensor.
    
    """
    factors = factors.type_as(tensor)
    
    bsz, csz = frame.shape[:2]
    frame_shape = (bsz, csz) + (1,)*(tensor.dim()-2)

    if mask is not None:
        # perform the operation on the complete field and only update
        # where the mask is True
        tensor[mask] = tensor.mul(frame.view(frame_shape)*factors)[mask]
    else:
        tensor.mul_(frame.view(frame_shape)*factors)

    return tensor



def divide_frame_(tensor, frame, factors, mask=None):
    """ Divide every frame (third dimension) by individual values 
    considering a channel (second dimension) independent factor.
    
    In-place operation (mutates input tensor!).
    
    ----------
    ARGUMENTS
    
        tensor: tensor image of size (N, C, D, ..., H, W) to be modified.
        frame: tensor with the dividing scalars for every frame
               (third dimension), all other dimensions (except the
               2D array) must be the same. The format generated by
               mean_first_frame or std_first_frame.
        factors: tensor with the value for scaling the multiplication
                 for each channel (must have as much values as channels -
                 second dimension). Ex: if [3, 1, 2], the first
                 channel is divided by 3*frame[:,0], the second by 
                 1*frame[:,1] and the third by 2*frame[:,2].
    
    ----------         
    RETURNS

        tensor: tensor image of multiplied tensor.
    
    """
    factors = factors.type_as(tensor)
    
    bsz, csz = frame.shape[:2]
    frame_shape = (bsz, csz) + (1,)*(tensor.dim()-2)

    if mask is not None:
        # perform the operation on the complete field and only update
        # where the mask is True
        tensor[mask] = tensor.div(frame.view(frame_shape)*factors)[mask]
    else:
        tensor.div_(frame.view(frame_shape)*factors)

    return tensor



def add_frame_(tensor, frame, factors, mask=None):
    """ Add to every frame (third dimension) individual values 
    considering a channel (second dimension) independent factor.
    
    In-place operation (mutates input tensor!).
    
    ----------    
    ARGUMENTS
    
        tensor: tensor image of size (N, C, D, ..., H, W) to be modified.
        frame: tensor with the dividing scalars for every frame
               (third dimension), all other dimensions (except the
               2D array) must be the same. The format generated by
               mean_first_frame or std_first_frame.
        factors: tensor with the value for scaling the addition
                 for each channel (must have as much values as channels -
                 second dimension). Ex: if [3, 1, 2], the first
                 channel is added with 3*frame[:,0], the second by 
                 1*frame[:,1] and the third by 2*frame[:,2].
    
    ----------                 
    RETURNS

        tensor: tensor image of multiplied tensor.
    
    """
    factors = factors.type_as(tensor)

    bsz, csz = frame.shape[:2]
    frame_shape = (bsz, csz) + (1,)*(tensor.dim()-2)

    if mask is not None:
        # perform the operation on the complete field and only update
        # where the mask is True
        tensor[mask] = tensor.add(frame.view(frame_shape)*factors)[mask]
    else:
        tensor.add_(frame.view(frame_shape)*factors)

    return tensor

def offset_(tensor, scalars):       
    """ Apply an offset for the each channel in the tensor. 

    In-place operation (modifies input tensor!). Channel must be
    the second dimension!

    ----------
    ARGUMENTS

        tensor: tensor image of size (N, C, ..., H, W) to be
                modified.
        scalars: tensor with the scalar to add in each channel

    ----------
    RETURNS

        tensor: tensor image with offset.

    """
    scalars = scalars.type_as(tensor)

    # offset shape is (1, C, ...)
    offset_shape = (1, scalars.numel()) + (1,)*(tensor.dim()-2)
    offsets = scalars.view(offset_shape)

    tensor.add_(offsets)

    return tensor


def multiply_(tensor, scalars):       
    """ Apply a multiplication for the each channel in the tensor. 

    In-place operation (modifies input tensor!). Channel must be
    the second dimension!

    ----------
    ARGUMENTS

        tensor: tensor image of size (N, C, ..., H, W) to be
                modified.
        scalars: tensor with the scalar to multiply in each channel

    ----------
    RETURNS

        tensor: tensor image with offset.

    """
    scalars = scalars.type_as(tensor)

    # offset shape is (1, C, ...)
    offset_shape = (1, scalars.numel()) + (1,)*(tensor.dim()-2)
    offsets = scalars.view(offset_shape)

    tensor.mul_(offsets)
    
    return tensor


"""
Data augmentation functions and classes
"""
class RandomFlip():
    """ In-place flips of the last 2 dimensions of a tensor
    
    Options:
    
        0 : no flip
        1 : flip vertical (-y)
        2 : flip horizontal (-x)
        3 : flip horizontal & vertical (-x, -y)
        
    """
    def __init__(self):
        self.flips = [self.no_flip_,
                      self.flip_vertical_,
                      self.flip_horizontal_,
                      self.flip_both_]
    
    def no_flip_(self, data):
        pass
        
    def flip_horizontal_(self, data):
        data.data = torch.flip(data, dims=[-1])
        
    def flip_vertical_(self, data):
        data.data = torch.flip(data, dims=[-2])
        
    def flip_both_(self, data):
        data.data = torch.flip(data, dims=[-2,-1])
        
    def __call__(self, data):
        """ Apply a random flip.
        
        Gets a random integer between 0 and 3 to select the
        flip operation to apply.
        
        ----------
        ARGUMENTS
        
            data: tensor to flip. Operation is performed
                  in-place
        
        """        
        d4dice = torch.randint(high=4,size=(1,))
        self.flips[d4dice](data)
        
        
